/**********************************************************************
  u[N|Cg̍폜
  $Id: dbp_cmd.c,v 1.4 2003/07/06 01:37:02 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int  dbp_parse_opt(struct GETOPT_ARG *args) ;
void dbp_print_help() ;

int dbp_cmd( struct GETOPT_ARG *args , int mode )
{
  int i,j ;
  int pid,id ;
  int deleted ; 
  int ret ;
  
  ret=dbp_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  if( XGETOPT_REFARGP(args,1)==NULL ){
    SYSMSG("Invalid break point ID.\n") ;
    return(NORMAL_EXIT) ;
  }else{
    id=exatoi(XGETOPT_REFARGP(args,1)) ;
  }
  
  if( XGETOPT_REFARGP(args,2)==NULL ){
    pid=proc_list.cur_id ;
  }else{
    if( XGETOPT_REFARGP(args,2)[0]=='+' ){
      pid=proc_list.cur_id+1 ;
    }else{
      if( XGETOPT_REFARGP(args,2)[0]=='-' ){
	pid=proc_list.cur_id-1 ;
      }else{
	pid=exatoi(XGETOPT_REFARGP(args,2)) ;
      }
    }
    if( pid>=MAX_PROCESS_ID || pid<0 ){
      SYSMSG("Invalid Process ID (Min=0,Max=%d specify=%d).\n",
	     (MAX_PROCESS_ID)-1,pid) ;
      return(NORMAL_EXIT) ;
    }
  }
  
  deleted=NO ;
  for( i=0 ; i<proc_list.proc[pid].bp_num ; i++ ){
    if( proc_list.proc[pid].bp[i].id == id ){
      free(proc_list.proc[pid].bp[i].label) ;
      for( j=i ; j<proc_list.proc[pid].bp_num ; j++ ){
	proc_list.proc[pid].bp[j].id = proc_list.proc[pid].bp[j+1].id ;
      }
      proc_list.proc[pid].bp_num-- ;
      deleted=YES ;
      break ;
    }
  }
  
  if( deleted==NO ){
    SYSMSG("ID=%d is not set.\n",id) ;
  }
  
  return(NORMAL_EXIT) ;
  
}


int dbp_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      dbp_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void dbp_print_help()
{
  SYSERR(
	 "Delete break point\n"
	 "Usage: dbp brkID [pid|+|-]\n"
	 "  brkID : break point ID\n"
	 "  pid   : process ID\n"
	 "   +    : same current process ID+1\n"
	 "   -    : same current process ID-1\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     bpR}hŐݒ肵u[N|Cg̍폜s܂BvZXID\n"
	 "    w肵ꍇ͎w肵vZXID̃u[N|Cg폜܂B\n"
	 "    vZXIDȗꍇ̓JgvZXɐݒ肳ꂽu[N|Cg\n"
	 "    폜܂B\n"
	 ) ;
}
